require 'active_record'
# require 'active_support/all'

# require 'active_record/connection_adapters/for_alter'

require 'arrival/version'
require 'arrival/railtie'
# require 'arrival/runner'
require 'active_record/connection_adapters/for_alter'
# require 'arrival/cli_generator'
# require 'arrival/configuration'

# require 'arrival/log_sanitizers/password_sanitizer'
require 'arrival/runner'
require 'arrival/cli_generator'
require 'arrival/logger'
# require 'arrival/null_logger'
# require 'arrival/logger_factory'
require 'arrival/configuration'
require 'arrival/errors'
require 'arrival/command'

# require 'arrival/railtie' if defined?(Rails)

# # We need the OS not to buffer the IO to see pt-osc's output while migrating
# $stdout.sync = true

module Arrival
  class << self
    attr_accessor :configuration
  end

  def self.configure
    self.configuration ||= Configuration.new
    yield(configuration)
  end

  # Hooks Arrival into Rails migrations by replacing the configured
  # database adapter
  def self.load
    ActiveRecord::Migration.class_eval do
      alias_method :original_migrate, :migrate

      # Replaces the current connection adapter with the PerconaAdapter and
      # patches LHM, then it continues with the regular migration process.
      #
      # @param direction [Symbol] :up or :down
      def migrate(direction)
        reconnect_with_arrival
        # include_foreigner if defined?(Foreigner)

        # ::Lhm.migration = self
        original_migrate(direction)
      end

      # Includes the Foreigner's Mysql2Adapter implemention in
      # ArrivalAdapter to support foreign keys
      # def include_foreigner
      #   Foreigner::Adapter.safe_include(
      #     :ArrivalAdapter,
      #     Foreigner::ConnectionAdapters::Mysql2Adapter
      #   )
      # end

      # Make all connections in the connection pool to use PerconaAdapter
      # instead of the current adapter.
      def reconnect_with_arrival
        ActiveRecord::Base.establish_connection(
          TestDatabase.new.env_config.merge("adapter" => "arrival")
        )
      end
    end
  end
end
